
#include <strstream.h>
#include <iomanip>
#include <string>
#include <Regex.h>
#include "h5util.h"

/******************************************************

Functions regindex, hexstring,id2dods, and dods2id 
are from HDF-DODS server. The purpose of these functions 
are translating the WWW convention of escaping such
characters by replacing them with "%" followed by the hexadecimal
value of their ASCII code is used.  For example, "Raster Image #1"
becomes "Raster%20Image%20%231".

Kent Yang 5/31/2001, **************/
int
regindex(const string & s, const Regex & r, int index)
{
    int matchlen;

    return r.search(s.c_str(), s.size(), matchlen, index);
}

#if 0
string
hexstring(unsigned char val)
{
    static char buf[MAXSTR];

    ostrstream(buf, MAXSTR) << hex << setw(2) << setfill('0') <<
	(unsigned int) val << ends;

    return (string) buf;
}
#endif

// replace characters that are not allowed in DODS identifiers
#if 0
string
id2dods(string s)
{
    static Regex badregx("[^0-9a-zA-Z_%]");
    static const string ESC = "%";

    int index = 0;

    while ((index = regindex(s, badregx, index)) >= 0)
	s.replace(index, 1, ESC + hexstring(s[index]));
    if (isdigit(s[0]))
	s.insert(0, '_');
    return s;
}
#endif

#if 0
string dods2id(string s) {
    static Regex escregx("%[0-7][0-9a-fA-F]");

    int index=0;
    while ( (index = regindex(s, escregx, index)) != -1)
	s.replace(index, 3, unhexstring(s.substr(index+1,2)));

    return s;
}
#endif



